# Configuration ## List token validation configurations `client.tokenValidation.configuration.list(ConfigurationListParamsparams, RequestOptionsoptions?): V4PagePaginationArray` **get** `/zones/{zone_id}/token_validation/config` Lists all token validation configurations for this zone ### Parameters - `params: ConfigurationListParams` - `zone_id: string` Path param: Identifier. - `page?: number` Query param: Page number of paginated results. - `per_page?: number` Query param: Maximum number of results per page. ### Returns - `TokenConfig` - `id: string` UUID. - `created_at: string` - `credentials: Credentials` - `keys: Array` - `APIShieldCredentialsJWTKeyRSA` JSON representation of an RSA key. - `alg: "RS256" | "RS384" | "RS512" | 3 more` Algorithm - `"RS256"` - `"RS384"` - `"RS512"` - `"PS256"` - `"PS384"` - `"PS512"` - `e: string` RSA exponent - `kid: string` Key ID - `kty: "RSA"` Key Type - `"RSA"` - `n: string` RSA modulus - `APIShieldCredentialsJWTKeyEcEs256` JSON representation of an ES256 key - `alg: "ES256"` Algorithm - `"ES256"` - `crv: "P-256"` Curve - `"P-256"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `APIShieldCredentialsJWTKeyEcEs384` JSON representation of an ES384 key - `alg: "ES384"` Algorithm - `"ES384"` - `crv: "P-384"` Curve - `"P-384"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `description: string` - `last_updated: string` - `title: string` - `token_sources: Array` - `token_type: "JWT"` - `"JWT"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const tokenConfig of client.tokenValidation.configuration.list({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', })) { console.log(tokenConfig.id); } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": [ { "id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "created_at": "2014-01-01T05:20:00.12345Z", "credentials": { "keys": [ { "alg": "ES256", "crv": "P-256", "kid": "38013f13-c266-4eec-a72a-92ec92779f21", "kty": "EC", "x": "KN53JRwN3wCjm2o39bvZUX2VdrsHzS8pxOAGjm8m7EQ", "y": "lnkkzIxaveggz-HFhcMWW15nxvOj0Z_uQsXbpK0GFcY" } ] }, "description": "Long description for Token Validation Configuration", "last_updated": "2014-01-01T05:20:00.12345Z", "title": "Example Token Validation Configuration", "token_sources": [ "http.request.headers[\"x-auth\"][0]", "http.request.cookies[\"Authorization\"][0]" ], "token_type": "JWT" } ], "success": true, "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000, "total_pages": 100 } } ``` ## Get a single Token Configuration `client.tokenValidation.configuration.get(stringconfigId, ConfigurationGetParamsparams, RequestOptionsoptions?): TokenConfig` **get** `/zones/{zone_id}/token_validation/config/{config_id}` Get a single Token Configuration ### Parameters - `configId: string` UUID. - `params: ConfigurationGetParams` - `zone_id: string` Identifier. ### Returns - `TokenConfig` - `id: string` UUID. - `created_at: string` - `credentials: Credentials` - `keys: Array` - `APIShieldCredentialsJWTKeyRSA` JSON representation of an RSA key. - `alg: "RS256" | "RS384" | "RS512" | 3 more` Algorithm - `"RS256"` - `"RS384"` - `"RS512"` - `"PS256"` - `"PS384"` - `"PS512"` - `e: string` RSA exponent - `kid: string` Key ID - `kty: "RSA"` Key Type - `"RSA"` - `n: string` RSA modulus - `APIShieldCredentialsJWTKeyEcEs256` JSON representation of an ES256 key - `alg: "ES256"` Algorithm - `"ES256"` - `crv: "P-256"` Curve - `"P-256"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `APIShieldCredentialsJWTKeyEcEs384` JSON representation of an ES384 key - `alg: "ES384"` Algorithm - `"ES384"` - `crv: "P-384"` Curve - `"P-384"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `description: string` - `last_updated: string` - `title: string` - `token_sources: Array` - `token_type: "JWT"` - `"JWT"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const tokenConfig = await client.tokenValidation.configuration.get( '4a7ee8d3-dd63-4ceb-9d5f-c27831854ce7', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }, ); console.log(tokenConfig.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "created_at": "2014-01-01T05:20:00.12345Z", "credentials": { "keys": [ { "alg": "ES256", "crv": "P-256", "kid": "38013f13-c266-4eec-a72a-92ec92779f21", "kty": "EC", "x": "KN53JRwN3wCjm2o39bvZUX2VdrsHzS8pxOAGjm8m7EQ", "y": "lnkkzIxaveggz-HFhcMWW15nxvOj0Z_uQsXbpK0GFcY" } ] }, "description": "Long description for Token Validation Configuration", "last_updated": "2014-01-01T05:20:00.12345Z", "title": "Example Token Validation Configuration", "token_sources": [ "http.request.headers[\"x-auth\"][0]", "http.request.cookies[\"Authorization\"][0]" ], "token_type": "JWT" }, "success": true } ``` ## Create a new Token Validation configuration `client.tokenValidation.configuration.create(ConfigurationCreateParamsparams, RequestOptionsoptions?): TokenConfig` **post** `/zones/{zone_id}/token_validation/config` Create a new Token Validation configuration ### Parameters - `params: ConfigurationCreateParams` - `zone_id: string` Path param: Identifier. - `credentials: Credentials` Body param - `keys: Array` - `APIShieldCredentialsJWTKeyRSA` JSON representation of an RSA key. - `alg: "RS256" | "RS384" | "RS512" | 3 more` Algorithm - `"RS256"` - `"RS384"` - `"RS512"` - `"PS256"` - `"PS384"` - `"PS512"` - `e: string` RSA exponent - `kid: string` Key ID - `kty: "RSA"` Key Type - `"RSA"` - `n: string` RSA modulus - `APIShieldCredentialsJWTKeyEcEs256` JSON representation of an ES256 key - `alg: "ES256"` Algorithm - `"ES256"` - `crv: "P-256"` Curve - `"P-256"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `APIShieldCredentialsJWTKeyEcEs384` JSON representation of an ES384 key - `alg: "ES384"` Algorithm - `"ES384"` - `crv: "P-384"` Curve - `"P-384"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `description: string` Body param - `title: string` Body param - `token_sources: Array` Body param - `token_type: "JWT"` Body param - `"JWT"` ### Returns - `TokenConfig` - `id: string` UUID. - `created_at: string` - `credentials: Credentials` - `keys: Array` - `APIShieldCredentialsJWTKeyRSA` JSON representation of an RSA key. - `alg: "RS256" | "RS384" | "RS512" | 3 more` Algorithm - `"RS256"` - `"RS384"` - `"RS512"` - `"PS256"` - `"PS384"` - `"PS512"` - `e: string` RSA exponent - `kid: string` Key ID - `kty: "RSA"` Key Type - `"RSA"` - `n: string` RSA modulus - `APIShieldCredentialsJWTKeyEcEs256` JSON representation of an ES256 key - `alg: "ES256"` Algorithm - `"ES256"` - `crv: "P-256"` Curve - `"P-256"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `APIShieldCredentialsJWTKeyEcEs384` JSON representation of an ES384 key - `alg: "ES384"` Algorithm - `"ES384"` - `crv: "P-384"` Curve - `"P-384"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `description: string` - `last_updated: string` - `title: string` - `token_sources: Array` - `token_type: "JWT"` - `"JWT"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const tokenConfig = await client.tokenValidation.configuration.create({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', credentials: { keys: [ { alg: 'ES256', crv: 'P-256', kid: '38013f13-c266-4eec-a72a-92ec92779f21', kty: 'EC', x: 'KN53JRwN3wCjm2o39bvZUX2VdrsHzS8pxOAGjm8m7EQ', y: 'lnkkzIxaveggz-HFhcMWW15nxvOj0Z_uQsXbpK0GFcY', }, ], }, description: 'Long description for Token Validation Configuration', title: 'Example Token Validation Configuration', token_sources: ['http.request.headers["x-auth"][0]', 'http.request.cookies["Authorization"][0]'], token_type: 'JWT', }); console.log(tokenConfig.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "created_at": "2014-01-01T05:20:00.12345Z", "credentials": { "keys": [ { "alg": "ES256", "crv": "P-256", "kid": "38013f13-c266-4eec-a72a-92ec92779f21", "kty": "EC", "x": "KN53JRwN3wCjm2o39bvZUX2VdrsHzS8pxOAGjm8m7EQ", "y": "lnkkzIxaveggz-HFhcMWW15nxvOj0Z_uQsXbpK0GFcY" } ] }, "description": "Long description for Token Validation Configuration", "last_updated": "2014-01-01T05:20:00.12345Z", "title": "Example Token Validation Configuration", "token_sources": [ "http.request.headers[\"x-auth\"][0]", "http.request.cookies[\"Authorization\"][0]" ], "token_type": "JWT" }, "success": true } ``` ## Edit an existing Token Configuration `client.tokenValidation.configuration.edit(stringconfigId, ConfigurationEditParamsparams, RequestOptionsoptions?): ConfigurationEditResponse` **patch** `/zones/{zone_id}/token_validation/config/{config_id}` Edit fields of an existing Token Configuration ### Parameters - `configId: string` UUID. - `params: ConfigurationEditParams` - `zone_id: string` Path param: Identifier. - `description?: string` Body param - `title?: string` Body param - `token_sources?: Array` Body param ### Returns - `ConfigurationEditResponse` - `id?: string` UUID. - `description?: string` - `title?: string` - `token_sources?: Array` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const response = await client.tokenValidation.configuration.edit( '4a7ee8d3-dd63-4ceb-9d5f-c27831854ce7', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }, ); console.log(response.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "description": "Long description for Token Validation Configuration", "title": "Example Token Validation Configuration", "token_sources": [ "http.request.headers[\"x-auth\"][0]", "http.request.cookies[\"Authorization\"][0]" ] }, "success": true } ``` ## Delete Token Configuration `client.tokenValidation.configuration.delete(stringconfigId, ConfigurationDeleteParamsparams, RequestOptionsoptions?): ConfigurationDeleteResponse` **delete** `/zones/{zone_id}/token_validation/config/{config_id}` Delete Token Configuration ### Parameters - `configId: string` UUID. - `params: ConfigurationDeleteParams` - `zone_id: string` Identifier. ### Returns - `ConfigurationDeleteResponse` - `id?: string` UUID. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const configuration = await client.tokenValidation.configuration.delete( '4a7ee8d3-dd63-4ceb-9d5f-c27831854ce7', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }, ); console.log(configuration.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415" }, "success": true } ``` ## Domain Types ### Token Config - `TokenConfig` - `id: string` UUID. - `created_at: string` - `credentials: Credentials` - `keys: Array` - `APIShieldCredentialsJWTKeyRSA` JSON representation of an RSA key. - `alg: "RS256" | "RS384" | "RS512" | 3 more` Algorithm - `"RS256"` - `"RS384"` - `"RS512"` - `"PS256"` - `"PS384"` - `"PS512"` - `e: string` RSA exponent - `kid: string` Key ID - `kty: "RSA"` Key Type - `"RSA"` - `n: string` RSA modulus - `APIShieldCredentialsJWTKeyEcEs256` JSON representation of an ES256 key - `alg: "ES256"` Algorithm - `"ES256"` - `crv: "P-256"` Curve - `"P-256"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `APIShieldCredentialsJWTKeyEcEs384` JSON representation of an ES384 key - `alg: "ES384"` Algorithm - `"ES384"` - `crv: "P-384"` Curve - `"P-384"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `description: string` - `last_updated: string` - `title: string` - `token_sources: Array` - `token_type: "JWT"` - `"JWT"` ### Configuration Edit Response - `ConfigurationEditResponse` - `id?: string` UUID. - `description?: string` - `title?: string` - `token_sources?: Array` ### Configuration Delete Response - `ConfigurationDeleteResponse` - `id?: string` UUID. # Credentials ## Update Token Configuration credentials `client.tokenValidation.configuration.credentials.update(stringconfigId, CredentialUpdateParamsparams, RequestOptionsoptions?): CredentialUpdateResponse` **put** `/zones/{zone_id}/token_validation/config/{config_id}/credentials` Update Token Configuration credentials ### Parameters - `configId: string` UUID. - `params: CredentialUpdateParams` - `zone_id: string` Path param: Identifier. - `keys: Array` Body param - `APIShieldCredentialsJWTKeyRSA` JSON representation of an RSA key. - `alg: "RS256" | "RS384" | "RS512" | 3 more` Algorithm - `"RS256"` - `"RS384"` - `"RS512"` - `"PS256"` - `"PS384"` - `"PS512"` - `e: string` RSA exponent - `kid: string` Key ID - `kty: "RSA"` Key Type - `"RSA"` - `n: string` RSA modulus - `APIShieldCredentialsJWTKeyEcEs256` JSON representation of an ES256 key - `alg: "ES256"` Algorithm - `"ES256"` - `crv: "P-256"` Curve - `"P-256"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `APIShieldCredentialsJWTKeyEcEs384` JSON representation of an ES384 key - `alg: "ES384"` Algorithm - `"ES384"` - `crv: "P-384"` Curve - `"P-384"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate ### Returns - `CredentialUpdateResponse` - `errors: Message` - `code: number` - `message: string` - `documentation_url?: string` - `source?: Source` - `pointer?: string` - `keys: Array` - `APIShieldCredentialsJWTKeyRSA` JSON representation of an RSA key. - `alg: "RS256" | "RS384" | "RS512" | 3 more` Algorithm - `"RS256"` - `"RS384"` - `"RS512"` - `"PS256"` - `"PS384"` - `"PS512"` - `e: string` RSA exponent - `kid: string` Key ID - `kty: "RSA"` Key Type - `"RSA"` - `n: string` RSA modulus - `APIShieldCredentialsJWTKeyEcEs256` JSON representation of an ES256 key - `alg: "ES256"` Algorithm - `"ES256"` - `crv: "P-256"` Curve - `"P-256"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `APIShieldCredentialsJWTKeyEcEs384` JSON representation of an ES384 key - `alg: "ES384"` Algorithm - `"ES384"` - `crv: "P-384"` Curve - `"P-384"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `messages: Message` - `success: true` Whether the API call was successful. - `true` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const credential = await client.tokenValidation.configuration.credentials.update( '4a7ee8d3-dd63-4ceb-9d5f-c27831854ce7', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', keys: [ { alg: 'ES256', crv: 'P-256', kid: '38013f13-c266-4eec-a72a-92ec92779f21', kty: 'EC', x: 'KN53JRwN3wCjm2o39bvZUX2VdrsHzS8pxOAGjm8m7EQ', y: 'lnkkzIxaveggz-HFhcMWW15nxvOj0Z_uQsXbpK0GFcY', }, ], }, ); console.log(credential.errors); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "keys": [ { "alg": "ES256", "crv": "P-256", "kid": "38013f13-c266-4eec-a72a-92ec92779f21", "kty": "EC", "x": "KN53JRwN3wCjm2o39bvZUX2VdrsHzS8pxOAGjm8m7EQ", "y": "lnkkzIxaveggz-HFhcMWW15nxvOj0Z_uQsXbpK0GFcY" } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true } ``` ## Domain Types ### Credential Update Response - `CredentialUpdateResponse` - `errors: Message` - `code: number` - `message: string` - `documentation_url?: string` - `source?: Source` - `pointer?: string` - `keys: Array` - `APIShieldCredentialsJWTKeyRSA` JSON representation of an RSA key. - `alg: "RS256" | "RS384" | "RS512" | 3 more` Algorithm - `"RS256"` - `"RS384"` - `"RS512"` - `"PS256"` - `"PS384"` - `"PS512"` - `e: string` RSA exponent - `kid: string` Key ID - `kty: "RSA"` Key Type - `"RSA"` - `n: string` RSA modulus - `APIShieldCredentialsJWTKeyEcEs256` JSON representation of an ES256 key - `alg: "ES256"` Algorithm - `"ES256"` - `crv: "P-256"` Curve - `"P-256"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `APIShieldCredentialsJWTKeyEcEs384` JSON representation of an ES384 key - `alg: "ES384"` Algorithm - `"ES384"` - `crv: "P-384"` Curve - `"P-384"` - `kid: string` Key ID - `kty: "EC"` Key Type - `"EC"` - `x: string` X EC coordinate - `y: string` Y EC coordinate - `messages: Message` - `success: true` Whether the API call was successful. - `true`